#include "12864.h"
#include "ads1115.h"
#include "KeyBoard.h"
/********************************************************************
*  : sendbyte()
*  : ҺĴͨЭ飬
*  : zdata
*  : 
***********************************************************************/
float adv1,adi2;
unsigned char display1[6]={0,'.',0,0,0,0};
unsigned char display2[6]={0,0,'.',0,0,0};
void sendbyte(unsigned char zdata)
{
        unsigned int i;
        for(i=0; i<8; i++)
        {
                if((zdata << i) & 0x80)
                {
                        SID_1;
                }
                else 
                {
                        SID_0;
                }
                SCLK_12864_0;
                delay_ms(1);
                SCLK_12864_1;
        }
}

/********************************************************************
*  : write_com()
*  : дָ
*  : cmdcode
*  : 
***********************************************************************/
void write_com(unsigned char cmdcode)
{
        //CS_1;
        sendbyte(0xf8);
        sendbyte(cmdcode & 0xf0);
        sendbyte((cmdcode << 4) & 0xf0);
        delay_us(200);
}

/********************************************************************
*  : write_data()
*  : дָ
*  : cmdcode
*  : 
***********************************************************************/
void write_data(unsigned char Dispdata)
{
       // CS_1;
        sendbyte(0xfa);
        sendbyte(Dispdata & 0xf0);
        sendbyte((Dispdata << 4) & 0xf0);
        delay_us(200);
}

/********************************************************************
*  : lcdinit()
*  : ʼ
*  : cmdcode
*  : 
***********************************************************************/
void lcdinit(void)
{  
        RST_0;
        delay_ms(2);
        delay_ms(2);
        RST_1;
        delay_ms(2);
        delay_ms(2);
        write_com(0x30);
        delay_ms(1);
        delay_ms(2);
        write_com(0x0c);
        delay_ms(2);
        delay_ms(2);
}

/********************************************************************
*  : hzkdis()
*  : ʾַ
*  : *s
*  : 
***********************************************************************/
void hzkdis(unsigned char *s)
{  
        while(*s > 0)
    { 
                write_data(*s);
                s++;
                delay_ms(2);
                delay_ms(2);
    }
}

void Test_12864(void)
{  
        write_com(0x03);
        delay_ms(2); 
        delay_ms(2);
        write_com(0x80);
        hzkdis("趨 ");
        write_com(0x84);
        hzkdis("      A ");
        write_com(0x90);
        hzkdis("ֵ ");
        write_com(0x94);
        hzkdis("      A ");
        write_com(0x88);
        hzkdis("ѹֵ:  ");
        write_com(0x98);
        hzkdis("ʣ ");
        write_com(0x9C);
        hzkdis("       % ");
        write_com(0x8D);
        hzkdis("    V");   
}

void  init_12864(void)
{
  P1DIR |= BIT5;
  P1DIR |= BIT6;
  P1DIR |= BIT7;
  P2DIR |= BIT0;
  P2DIR |= BIT1;
}
void to_char(unsigned char *display_bufer,float adc)
{
    unsigned int   adc1000;
    adc1000=(unsigned int)adc*1000;
    display_bufer[0]=adc1000/1000+48;
    display_bufer[2]=adc1000/100%10+48;
    display_bufer[3]=adc1000/10%10+48;
    //display_bufer[4]=adc1000/10%10+48;
    //display_bufer[5]=adc1000/10%10+48; 
    display_bufer[4]=adc1000%10+48;
}
 void to_char2(unsigned char *display_bufer,float adc)
{
    unsigned int   adc1000;
    adc1000=(unsigned int)adc*1000;
    display_bufer[0]=adc1000/10000+48;
    display_bufer[1]=adc1000/1000%10+48;
    display_bufer[3]=adc1000/100%10+48;
    display_bufer[4]=adc1000/10%10+48;
    //display_bufer[4]=adc1000/10%10+48;
    //display_bufer[5]=adc1000/10%10+48; 
    //display_bufer[4]=adc1000%10+48;
}
void test(void)
{
      //ʾ趨ֵ
      to_char(display1,setpoint);
      write_com(0x84);
      delay_ms(2);
      hzkdis(display1);
      //ʾѹֵ
      //to_char(display1,adv1);
      to_char2(display2,adv1);
      
      write_com(0x8C);
      delay_ms(2);
      hzkdis(display2);
      //ʾʵʵֵ
      to_char(display1,adi2);
      write_com(0x94);
      delay_ms(2);
      hzkdis(display1);
      //ʾص
      to_char2(display2,fuzai());
      write_com(0x9C);
      hzkdis(display2);
      delay_ms(2);
      

}